using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

[Script(ScriptCategory.Move, "shadow_force")]
public class ShadowForce : Script, IScriptPreventMove, IScriptOnSecondaryEffect
{
    /// <inheritdoc />
    public void PreventMove(IExecutingMove move, ref bool prevent)
    {
        if (move.User.Volatile.Contains<ShadowForceCharge>())
            return;

        move.User.Volatile.Add(new ShadowForceCharge(move.User));
        move.MoveChoice.SetAdditionalData("shadow_force_charge", true);
        move.User.BattleData?.Battle.EventHook.Invoke(new DialogEvent("shadow_force_charge",
            new Dictionary<string, object>
            {
                { "user", move.User },
            }));
        prevent = true;
    }

    /// <inheritdoc />
    public void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
        if (move.User.Volatile.Contains<ShadowForceCharge>())
            return;

        move.User.Volatile.Add(new ShadowForceCharge(move.User));
    }
}